Adept eV+ Change Log
--------------------

Version 2.4 C10 Production Release build on 4/3/2020 at 12:11 PM

    [Fixed]
    - EVP2X-62 - INRANGE uses wrong location to check for collision when location is not specified
    - EVP2X-46 - PANIC error cannot be cleared in Manual mode
    - EVP2X-41 - WRITE command with negative record_num is not handled correctly
    - EVP2X-227 - Cleanup of Bug19627 regarding Bad License File message
    
Version 2.4 C9 Production Release build on 2/20/2020 at 12:41 AM

    [Fixed]
    - EVP2X-216 - Null pointer in disk operations can cause 'ESTOP circuit relay failure'
    - EVP2X-9 - Nester FOR loop can increment counter incorrectly
    - EVP2X-43 - eSeries Hornet exhibits low null time in 2.4
    - Bug 19538 - MODULE keyword cannot rearrange module contents like V+
    - Bug 19537 - Error(-2,0) returns 64893 after T20 ESTOP
    - Bug 19434 - eV+ Emulator can crash if variable class is redefined improperly
    - Bug 19527 - Erroneous "Bad License file" message is logged in Log.xml everytime eV+ reboot with valid license
    - Bug 19528 - Files "standard.cal" and "standard.v2" missing from eV+ release
    - Bug 18827 - STOREM saves module program incorrectly
    - Bug 19426 - GLOBAL arrays defined in program delete arrays (with same name) that are in memory
    
Version 2.4 C8 Production Release build on 6/14/2019 at 3:26 PM

    [Updated]
    - Updated FPGA to apply PWM to brakes on suitable hardware

Version 2.4 C7 Production Release build on 5/29/2019 at 4:46 PM

    [Fixed]
	- Bug 19418 - JogTo to invalid location has potential to cross envelope boundary
	- Bug 18784 - Inverted Cobra800 robot body obstacle slightly enlarged
	- Bug 19505 - DC_UPDAT modified to allow DINK/u-boot upgrade on corresponding controllers
	- Bug 19502 - Update Max DAC values for manual mode
	- Bug 19432 - DELETE keyword doesn't delete all programs and referenced variables
	- Bug 18849 - Devicenet config limit correction

Version 2.4 C6 Production Release build on 1/28/2019 at 4:40 PM

    [Fixed]
    - Bug 19463 - eV+ 2.4 Pendant communication issue
    - Bug 19479 - Motor velocity changes for joint move with different ACCEL
    - Bug 19485 - MOVEC issue using precision point as center
    - Bug 18730 - Implement ID(7,2) to show pendant comm connection status

Version 2.4 C5 Production Release build on 1/9/2019 at 11:27 AM


    [New]
    - GRAPHICS-related keywords will no longer appear in the V+ editor.
    [Fixed]
    - Bug 19452 - Dual Quattro PackXpert system can consume IOBuffers

Version 2.4 C4 Production Release build on 8/28/2018 at 3:27 PM

    [Updated]
    - Pendant Firmware updated to 2.4.3.4

Version 2.4 C3 Production Release build on 8/1/2018 at 3:20 PM

    [Fixed]
    - Bug 8988 - Handle string overflow in V+ programs
    - Bug 19365 - Jogging at trajectory rate less than 16ms causes overspeed
    - Bug 19275 - Motion immediately after BRAKE instruction is not executed
    - Bug 19377 - Handle buffer overrun in datalogger
    - Bug 19308 - Pendant COMP mode not in sync with eV+ jog modes

Version 2.4 C2 Production Release build on 6/8/2018 at 10:54 AM

Version 2.4 C2 Production Release build on 6/8/2018 at 9:36 AM

    [Updated]
    - Updated the PID gains for Mid-Range Cobra (450/500/650) robots

Version 2.4 C1 Production Release build on 4/22/2018 at 10:48 PM


Version 2.4 B10 Pilot Release build on 4/19/2018 at 10:25 PM

	[Fixed]
	- Bug 19299 - Teach Restrict Manual verification (internal) keyword not working in case of multiple robots connected
	- Bug 19303 - Cobra eAIB FPGA shows wrong version
	
Version 2.4 B9 Pilot Release build on 3/31/2018 at 8:06 PM

        [Updated]
        - ReadMe file to include current version of Pendant firmware.
        [Fixed]
        - Bug 19253 - PANIC Program Instruction not recognized
        - Bug 19248 - PANIC keyword disables power
        - Bug 19247 - Enhanced Trajectory License removal
        - Bug 19257 - Teach Restrict Configuration and Verification failures on eMB60
        - Bug 19218 - Verification of manual mode Teach Restrict fails on Hirata
        - Bug 19262 - I2C timeout during Teach Restrict Verification

Version 2.4 B8 Pilot Release build on 3/1/2018 at 12:46 PM

	[Fixed]
	- Bug 18682 - Invalid Variable File Load can crash eV+
	- Bug 19257 - Teach Restrict Configuration and Verification failures on eMB60
	- Bug 19218 - Verification of manual mode Teach Restrict fails on Hirata

Version 2.4 B7 Pilot Release build on 2/3/2018 at 11:05 PM

	[Fixed]
	- Bug 19218 - Veification of Hirata Teach Restrict fails
	- Bug 19220 - Remove rough calibration support for Hirata robots
	- Bug 19219 - 2.4B6 missing 3 new spec files
	
Version 2.4 B6 Pilot Release build on 1/22/2018 at 10:53 PM

    [NEW]
    - Hirata Implementation
    
	[Fixed]
	- Bug 19174 - 2.4 Emulator Cobra not jogging properly
    - Bug 19184 - Fix ZeroEncoder for Sigma7 MB10
    - Bug 19202 - Remove licenses for Cobra 450/500/650 robots
    - Bug 19157 - Servo Upgrade Fails With Multiple Versions
    - Bug 18974 - NFS Communication will cause controller dropout if too many packets lost
    - Bug 19065 - FOPENA does an FSEEK on a file even if the file was not successfully opened
    - Bug 18755 - DC_UPDAT will attempt to load dink environment on to 5200 DAPS
    - Bug 19014 - T20 pendant firmware upgrade hang caused by m.tmp missing

Version 2.4 B5 Pilot Release build on 9/20/2017 at 9:55 PM

	[Fixed]
	- Bug 18765 - Update ID keyword to show if the robot supports Joint Control
	- Bug 18993 - NFS Case Sensitivity Issue in eV+ 2.4
	- Bug 18942 - 2.3 C7 Belt Detach Unintentional Motion

Version 2.4 B4 Pilot Release build on 8/22/2017 at 4:10 PM

    [Fixed]
    - Bug 18735 - Array of locations (AUTO loc[100,100] ) exceeds the stack limit which crashes the EX.
    - Bug 18739 - eV+ slow speed limitation at prg speed of less than 0.1
    - Bug 18779 - Joints Drop if EN PO from FP during final stages of boot process
    - Bug 18864 - ePLC reports *undefined value* in ep.apply.cmd
    - Bug 18676 - ePLC reports *Undefined value* in ep.log.queue

Version 2.4 B3 Pilot Release build on 6/16/2017 at 2:10 PM

    [Fixed]
    - Bug 18609 - Cannot jog out of some singularity situation
    - Bug 18601 - NFS mount generates error -501 when creating sub-folder under NFS mountPath

Version 2.4 B2 Pilot Release build on 4/26/2017 at 7:06 PM

    [Fixed]
    - Bug 18608 - Pendant registers as connected through ID(6, 2) before the pendant has fully booted.
    - Bug 18606 - Cannot attach and use pendant when number of robots exceeds 4
    - Bug 18648 - Add the 750W sigma7 motor.

Version 2.4 B1 Pilot Release build on 4/4/2017 at 5:57 PM

Version 2.4 A19 Prototype Release build on 3/13/2017 at 5:41 PM

    [Fixed]
    - Bug 18591 - #PPOINT omits elements after a blank element

    [New]
    - Handling singularities in JOG World and Tool mode.
    - Implemented enhanced data logger.
    - Pendant T55 introduced.
    [Fixed]
    - Bug 18479 - FCMND 601 (ping) does not work with TCP node alias defined in a program
    - Bug 14577 - ZERO 1 and ZERO 2 should be allowed
    - Bug 18492 - Brake release on XBIO_IN2_6 does not work for AIB devices.
    - Bug 18416 - eV+ support for Pendant functions - State(8), SetMode Not Functioning
    - Bug 18527 - Robot can move from monitor or program when commanded from ACE in Manual Mode
    - Bug 18466 - Force sensor can be overloaded when booting in a mode with the XPIO enabled.
    - Bug 18136 - J4 Jump at the end of the G_JogToLocationMode test.
    - Bug 18535 - Sigma 7 motors cannot be calibrated and run in the python.
    - Bug 16170 - Add keyword and configuration elements to allow a user to set the name of a controller.
    - Bug 16613 - Emulator allows copying of long file names.
    - Bug 18509 - Datalogger cannot log raw address and opcode at the same time.
    - Bug 17453 - RSC_SET has errors with committing to the encoder cache on the sigma7 motors.    
    - Bug 18542 - When joged to the rotational limit, the quattro gets stuck and cannot rotate.

Version 2.4 A18 Prototype Release build on 1/23/2017 at 12:51 PM
Version 2.4 A17 Prototype Release build on 1/19/2017 at 6:49 PM

    [New]
    - NFS support for eV+.
    - Custom Icons for eV+.
    [Fixed]
    - Bug 18397 - EStop Hardware Delay should be different on large robots.
    - Bug 18413 - Pendant task does not work correctly with LISTR (LISTR SELECT(ROBOT, 1) specifically).
    - Bug 18279 - Robot obstacle settings fails to restore after V+ reset.
    - Bug 18383 - Reports of bad behavior when combining using the pendant(0) command with various other robot functions.
    - Bug 18279 - Robot obstacle settings fails to restore after V+ reset.
    - Bug 14656 - Graphical Window: Custom User Icons not implemented in eV+.
    - Bug 18279 - Robot obstacle settings fails to restore after V+ reset.

Version 2.4 A16 Prototype Release build on 12/27/2016 at 5:28 PM

    [Fixed]
    - Bug 18268 - XSTEP task 28 waits forever.
    - Bug 18289 - RDB.TASK 0, 628 doesn't return an error.
    - Bug 17730 - RSC_SET can return an error when committing data to new motors.
    - Bug 18296 - Discrepancy between Joint and Cartesian acceleration for Cobra 600/800.
    - Bug 18276 - SETL at monitor window can lock up eV+.
    - Bug 18280 - ePLC ep.cu.control will return an error if ePLC is not running.
    - Bug 18194 - ALTER x, y, z, rx, ry, rz in WORLD mode doesn't work in all six degrees of freedom.
    - Bug 18318 - Issues with ut.sg2.init and ut.sg2.enc.mode.
    - Bug 18319 - ePLCIO contains obsolete keywords.
    - Bug 18348 - NOOVERLAP causes *Position out of range Jt.8* on a Cobra.
    - Bug 353 - Need method to display TOOL for specified robot.
    - Bug 18357 - Communication with ePLC and an NJ controller will stop communicating after a long period of time.

Version 2.4 A15 Prototype Release build on 10/19/2016 at 8:44 PM

    [Update]
    - Bug 18007 - Auto-generate eV+ language definition XML using eV+ code.
    [Fixed]
    - Bug 18269 - ePLC in IO mode shouldn't issue an ESTOP when the communication is lost.
    - Bug 18043 - RSC_SET doesn't use the correct model number for the Viper 850 IP 54/65 and the Viper 2000.

Version 2.4 A14 Prototype Release build on 10/17/2016 at 12:15 PM

    [Updated]
    - Bug 18264 - ALTON has been changed to allow ALTON (lun) mode style but the lun is not handled properly.
    [Fixed]
    - Bug 18266 - BSTATUS and BELT.MODE don't behave correctly when the belt is stopped.
    - Bug 18043 - RSC_SET doesn't use the correct model number for the Viper 850 IP 54/65 and the Viper 2000.

Version 2.4 A13 Prototype Release build on 10/7/2016 at 12:52 PM

    [New]
    - [StringCal] Full implementation.
    - Bug 18007 - Auto-generate eV+ language definition XML using eV+ code and metadata as source.
    - Bug 17716 - Need to cleanup switches.
    [Fixed]
    - Bug 14650 - LISTR ERROR(-1,2) returns junk for eV+.
    - Bug 17251 - MOVEC of 180+ degree does not correctly rotate tool.
    - Bug 17852 - eV+ should report FireWire configuration errors at boot time.
    - Bug 17770 - Problem with Quattro +-180 theta roll.
    - Bug 17820 - FCMD(lun, 601) for a tcp lun should issue a ping command.
    - Bug 17952 - DELAY detaches from the belt.
    - Bug 15479 - configuration of serial port at boot not supported by eV+.
    - Bug 16428 - GETEVENT never returns event 20 and 21.
    - Bug 18187 - FOPEN (glun) $name, "/ICON/ARRAY", index.max, "/SIZE", dx, dy, "/POSITION", cx, cy reports a -454 *Missing argument*.
    - Bug 17854 - Conveyor tracking is rougher in eV+ 2.3.
    - Bug 17652 - Manual/Auto switch error.
    - Bug 18220 - FORCE.MODE 2 is not working for sSeries robots.
    - Bug 17580 - Soft Overspeed error can occur on quattro p34 when attempting to rotate away from the overlap section of the platform.
    - Bug 17454 - BELT.MODE = 8 filters all the errors and not just the belt window violations.
    - Bug 17813 - Crash when STAT is executed over ActiveV.
    - Bug 18193 - Change from Manual to Auto displays 'Success' on Monitor Window.
    - Bug 17296 - Devicenet response time is slower on an EX.
    - Bug 18171 - eV+ errors -643 instead of -921 when the muted safety gate is opened.

Version 2.4 A12 Prototype Release build on 8/11/2016 at 3:35 PM

    [New]
    - Bug 17776 - TCP READ doesn't stop at CR or LF.
    - Bug 7875 - Implement HOUR.METER.
    - Bug 15964 - Send serial number and other information in VSCAN broadcast.
    - Bug 18007 - Auto-generate eV+ language definition XML using eV+ code and metadata as source.
    [Fixed]
    - Bug 17846 - The conf.xsd file has a mismatch with the old version of config files and causes problems because of the way the sequence is set up.
    - Bug 17847 - RestrictJogToPendantInManualSwitch should be enabled by default.
    - Bug 17795 - log.xml can grow beyond the 5 MB limit.
    - Bug 17871 - /LOCAL_ADDRESS doesn't work on the EX.
    - Bug 17841 - eV+ (Emulator) should have a way to return the subnet mask of the interface on which it received incoming Ethernet data.
    - Bug 17895 - When upgrading that causes a dynamic download before manual reboot we are unable to connect to the controller.
    - Bug 17912 - Encoder utils don't recognize the sigma 5 encoders.
    - Bug 17511 - eCobras on an EX will get a Dynamic Download after every Servo reset.
    - Bug 17944 - Dynamic download can fail when setup is 2 3-axis hornets connected to an EX and entire setup is powered on at once.
    - Bug 17924 - ePLC IO Omron doesn't clear the Er when the communication is established.
    - Bug 17853 - The Viper re-configures itself for no apparent reason.
    - Bug 17947 - ePLC doesn't start if an AUTO program was started.
    - Bug 18001 - B0 appears on 2 digit display for no reason.
    - Bug 18002 - No error when disconnecting IOBlox from robot other than IOBLox plug 0.
    - Bug 17878 - eV+ returns the wrong error when trying to DEPART a belt.
    - Bug 18006 - Add the belt simulator to the test server and refine the belt test set.
    - Bug 17808 - READ does not accept list of variables via the "$in[]" syntax.
    - Bug 17793 - Soft overspeed error from hornet j4 out of range when Joint out of range error should be received.
    - Bug 17885 - The association of temperatures for the amps on a 6 axis robot are incorrect.
    - Bug 17691 - Tracking along X-axis seems slower with a Quattro.
    - Bug 18026 - Jog loop should catch *Soft Overspeed* errors before Servo does.
    - Bug 17890 - CALLing a program with composed belt transforms can crash eV+.
    - Bug 17904 - ePLC Connect cannot start if outputs 1-8 are not configured.
    - Bug 18088 - ePLC shows all inputs set to 1 when Signal 32 and 64 are high.
    - Bug 17393 - Running of new TCP Client thread can cause crash in the controller.
    - Bug 18069 - Cobra Sigma7 are not automatically set up with sigma7 motors.

Version 2.4 A11 Prototype Release build on 5/25/2016 at 7:13 PM

    [Fixed]
    - Bug 17815 - The Dynamic Download doesn't work in eV+ 2.4A10.
    - Bug 17830 - ePLC doesn't use the correct multicast address on an Emulator with multiple network interfaces.

Version 2.4 A10 Prototype Release build on 5/16/2016 at 7:09 PM

    [Updated]
    - Bug 17682 - Robots should have a minimum eSeries type in the configuration.
    [Fixed]
    - Bug 17743 - BITS 2001, 32 = xxx throws *Arithmetic Overflow*.
    - Bug 17741 - All the binary specfiles should end with .END.
    - Bug 17561 - Robots cannot operate when an unknown firewire node appears on the network.
    - Bug 17620 - You should not be able to jog multiple joints at a time in joint mode while in manual mode.
    - Bug 17810 - ePLC reports *Invalid approach parameter for this robot* when it shouldn't.
    - Bug 17809 - MOVEC should return *Arithmetic overflow* when the circle has an infinite radius.

Version 2.4 A9 Prototype Release build on 4/27/2016 at 9:43 PM

    [Fixed]
    - Bug 17717 - Quattro s650H should be the default Quattro in emulation mode.
    - Bug 17735 - LISTR INRANGE(HERE) Returns 8 instead of 0 indicating error with joint 4 on the hornet 565 fixed.
    - Bug 17736 - TERMINAL parameter always returns *Invalid argument*.
    - Bug 17753 - Emulator and EX return different error code for CD_2.
    - Bug 17755 - [ePLC] cmd_arc and cmd_circle don't allow the use of location 0.

Version 2.4 A8 Prototype Release build on 4/12/2016 at 6:29 PM

    [New]
    - Bug 6099 - Method to clear latch buffer requested.
    [Updated]
    - Bug 17694 - Lower the duty cycle for Jt4 Cobra Sigma 7.
    [Fixed]
    - Bug 17628 - eV+ doesn't report Jt4 overheating on Cobra Sigma 7.
    - Bug 17639 - eV+ does not set the correct number for the number of joints in a transform during HERE #tr.
    - Bug 17646 - Envelope error limits for Viper s850 have changed.
    - Bug 17531 - Devicenet Status (FCMND 761) returns an error every other time.
    - Bug 17668 - ASL throws *Undefined value* in sl.init.opcodes.
    - Bug 17560 - CD absolute path doesn't work properly.
    - Bug 17695 - eV+ can hang forever if there are too many robot axes configured.
    - Bug 17713 - eAIB/eMB can loose commissioning for no apparent reason.

Version 2.4 A7 Prototype Release build on 3/14/2016 at 11:44 AM

    [Fixed]
    - Bug 17631 - ePLC Define Pallet doesn't accept pallet #1.
    - Bug 17619 - ePLC doesn't return error -3010 *Cannot move relative to a pallet*.

Version 2.4 A6 Prototype Release build on 3/11/2016 at 4:47 PM

    [Fixed]
    - Bug 17620 - You should not be able to jog multiple joints at a time in joint mode while in manual mode.
    - Bug 17622 - Cobra has the incorrect value for the default max_error_decel parameter.

Version 2.4 A5 Prototype Release build on 3/9/2016 at 3:15 PM

    [New]
    - Bug 06827 - Identify which task robot is attached to.
    - Bug 17609 - Add a way to know if a robot is currently tracking a belt.
    - Bug 17598 - Improve WINDOW real valued function to include the upstream and downstream distance.
    - Bug 17610 - Add an optional error code to SETBELT.
    [Fixed]
    - Bug 17551 - Display of double variables is not properly rounded.
    - Bug 17561 - Robots cannot operate when an unknown firewire node appears on the network.
    - Bug 17590 - Standard.V2 and standard.cal are not part of eV+.

Version 2.4 A4 Prototype Release build on 2/23/2016 at 5:08 PM

    [New]
    - Bug 6099 - Method to clear latch buffer requested.
    - Bug 17482 - Add Align transformation function.
    [Fixed]
    - Bug 17502 - IOBlox are not recognized by the robot.
    - Bug 17513 - ePLC IO command tasks stops with error -311 *Invalid when program task active*.
    - Bug 17522 - CAL_UTIL doesn't load properly.
    - Bug 17547 - DECOMPOSE cuts the Precision Point variables.
    - Bug 17543 - eV+ cuts the Precision point variables.
    - Bug 17548 - ePLC Connect's heartbeat only beats every 32ms.

Version 2.4 A3 Prototype Release build on 2/8/2016 at 5:04 PM

    [Fixed]
    - Bug 17233 - ID should return the separate version numbers for the pendant.
    - Bug 17238 - Robot will not power on with 110V when using the diagnostics mode on eAIB.
    - Bug 17118 - [FPGA] 5200 FPGA doesn't record incremental encoder index properly.
    - Bug 17250 - Error "Custom Message Error" when running simple program on T20 Pendant.
    - Bug 15556 - Deadman switch in manual mode throws unknown error codes when released.
    - Bug 17243 - Switching to Jog mode on T20 with robot powered on and not calibrated can cause the robot to vibrate.
    - Bug 17292 - Input and Output size are switched when configured as a DeviceNet slave.
    - Bug 17215 - Starting bit position for signals is limited to 255.
    - Bug 17309 - SSeries Cobra cannot use the IO-Blox.
    - Bug 17312 - FCMND 601 is not implemented.
    - Bug 17332 - 24V check fails spuriously until robot restart.
    - Bug 17350 - IOSTAT(lun, 3) always return 0.
    - Bug 17364 - When a single user estop pole is thrown the system will require 2 en po to come up.
    - Bug 17365 - When ESTOP is thrown, power is disabled but robot continues in the manual state.
    - Bug 17363 - PENDANT(0) and Abort V+ task can result in incorrect return for PENDANT(-5).
    - Bug 17401 - Setting the debug parameter to ignore obstacles does not work while jogging.
    - Bug 17441 - vp_utils fail to build, this causes the eV+ emulator to fail to build.
    - Bug 16901 - Create a simple interface for encoder alarm reset.
    - Bug 17485 - The behavior of the Enable Break Release Input configuration is inverted.

Version 2.4 A2 Prototype Release build on 11/19/2015 at 2:14 PM

    [New]
    - Bug 16901 - Create a simple interface for encoder alarm reset.
    - Bug 17233 - ID should return the separate version numbers for the pendant.
    [Fixed]
    - Bug 17052 - Hornet cannot servo when turned on.
    - Bug 17058 - Using delay after tool change results in J3 out of range.
    - Bug 17100 - Multiple simultaneous JOG request can cause a *Trajectory Clock Overrun*.
    - Bug 17109 - Viper 700, 900 & 1100 J2 upper limit is incorrect.
    - Bug 17112 - Amp detection fails for 3 axis hornet.
    - Bug 17106 - Duration and delay take a lot longer than expected.
    - Bug 17116 - In the emulator 2.4 (VS2015) the scientific notation of 123000 is 1.23E5 instead of 1.23E05.
    - Bug 17118 - [FPGA] 5200 FPGA doesn't record incremental encoder index properly.
    - Bug 17119 - FCMD test failing to set a file modified time with switch 19 and 21.
    - Bug 17121 - FDELETE of an nonexistent file returns -502 *Illegal I/O device command* instead of -501 *Nonexistent file*.
    - Bug 17122 - LS does not order Directories first and the LS functional test fails.
    - Bug 17129 - Instructions accepting input arrays don't check the array length properly.
    - Bug 17117 - eV+ 2.2 and later don't load the User obstacle properly from a 2.1 diff file.
    - Bug 17139 - DEBUG parameter returns *Illegal I/O device command* for a Quattro.
    - Bug 17117 - eV+ 2.2 and later don't load the User obstacle properly from a 2.1 diff file.
    - Bug 17088 - T20 JogTo Align not working.
    - Bug 17146 - Self collision check for Vipers is not working.
    - Bug 17164 - LAST can throw *Undefined Value*.
    - Bug 16967 - T20 errors with monitoring key presses.
    - Bug 17159 - The default pattern for GTEXTURE is 0x0 but should be 0xFFFF.
    - Bug 17171 - MODULE sometimes skips a program name.
    - Bug 17170 - "Show References" does not show the reference for 'i'.
    - Bug 17161 - PDNT.NOTIFY - No easy way to clear display without showing the firmware menu.
    - Bug 17167 - When setting a global 2D array through a function pass, the value result has too many parts.
    - Bug 17118 - [FPGA] 5200 FPGA doesn't record incremental encoder index properly.
    - Bug 17226 - Large amounts of data sent to the pendant in PDNT.WRITE come out only partially when displayed.
    - Bug 17165 - PDNT.WRITE: $msg[] does not work if number of characters is too long.
    - Bug 17225 - TOOL program instruction freezes if T20 Pendant is in FREE Mode.

Version 2.4 A1 Prototype Release build on 9/28/2015 at 5:08 PM
